# -*- coding: UTF-8 -*-

from common import aif_objects as aif

class CatalogFactory:

    def __init__(self):
        self.mapGroup2Catalog = {}
        self.groupsWithParents = {}
        self.catalogs = []

    def setParams(self, currentConverter, groupsWithParents):
        '''
        Установить параметры из конфига
        '''
        self.groupsWithParents = groupsWithParents

        self.mapGroup2Catalog = currentConverter.group2CatalogMapper
        splitGroup = currentConverter.groupBindCode.split(';')
        splitCatalog = currentConverter.catalogBindCode.split(';')

        for i in range(len(splitGroup)):
            if i >= len(splitCatalog):
                break
            gr = splitGroup[i].strip()
            ct = splitCatalog[i].strip()
            if gr and ct:
                self.mapGroup2Catalog[gr] = ct

    def addInventCatalog(self, groupCode, inventCode):
        '''
        Добавить объект каталога
        '''
        catalogCode = self.getCatalogByGroup(groupCode)
        if catalogCode:
            self.catalogs.append(aif.InventCatalog().addCmd(tmccode=inventCode, catalogid=catalogCode))

    def getCatalogByGroup(self, groupCode):
        '''
        Получить код каталога для группы
        '''
        if groupCode in self.mapGroup2Catalog:
            return self.mapGroup2Catalog[groupCode]

        if groupCode in self.groupsWithParents:
            for groupParentCode in self.groupsWithParents.get(groupCode):
                if groupParentCode in self.mapGroup2Catalog:
                    return self.mapGroup2Catalog[groupParentCode]

        return None

    def getAifObjects(self):
        '''
        Получить aif объекты для отправки в inserter
        '''
        return self.catalogs
